############################################################################################################################
# Name:        StickyNades v2.2                                                                                            #
#                                                                                                                          #
# Author:      JoeyT2008                                                                                                   #
#                                                                                                                          #
# Description: Makes grenades stick to walls and players.                                                                  #
#                                                                                                                          #
#              1. When a grenade sticks to someone, it doesn't always stick in the right place...                          #
#                                                                                                                          #
# Notes:       1. To make a grenade stick to yourself, aim down and throw a grenade, it will then stick to your feet.      #
#              2. The model for the nade is from TF2, no credit goes to me whatsoever.                                     #
#                                                                                                                          #
# Credits:     Creator         JoeyT2008                                                                                   #
#                                                                                                                          #
#              Idea            JoeyT2008                                                                                   #
#                                                                                                                          #
#              Help            Errant                                                                                      #
#                              Saul                                                                                        #
#                              Lobe                                                                                        #
#                              Ajurna                                                                                      #
#                              Mattie                                                                                      #
#                              Superdave                                                                                   #
#                              Wonder                                                                                      #
#                              GODJonez                                                                                    #
#                              MBChrono                                                                                    #
#                              GLitched System                                                                             #
#                              Venjax                                                                                      #
#                                                                                                                          #
#              Testing         Saul                                                                                        #
#                              mupet0000                                                                                   #
#                              Errant                                                                                      #
#                                                                                                                          #
#              Parent Code     Wonder (from Venjax's emote mod) - Fixed by Errant                                          #
#                                                                                                                          #
#              Nade Model      Valve                                                                                       #
#                                                                                                                          #
#              Various CMD's   Everyone on IRC                                                                             #
############################################################################################################################
#           This is likely to be one of the last, if not the last update I will make to any of my addons. Sorry.           #
############################################################################################################################

import es, gamethread, vecmath, playerlib, random

info = es.AddonInfo()
info.name = "StickyNades"
info.version = "2.2"
info.author = "JoeyT2008"
info.url = "http://forums.mattie.info/cs/forums/viewtopic.php?t=17799"
info.description = "Allows grenades to stick to walls and players!"
info.basename = "stickynades"

oldEntList = {}
vPrepared = []
tVars = {}

######################
##START EDITING HERE##
######################

# Make HE Grenades stick to selected objects? 1=YES, 0=NO
tVars["sn_fragsticky"] = 1

# Make Flashbangs stick to selected objects? 1=YES, 0=NO
tVars["sn_flashsticky"] = 1

# Allow grenades to stick to walls? 1=YES, 0=NO
tVars["sn_sticktowalls"] = 1

# Allow grenades to stick to players? 1=YES, 0=NO
tVars["sn_sticktoplayers"] = 1

# Allow grenades to stick to their thrower? 1=YES, 0=NO
tVars["sn_sticktothrower"] = 0

# Play sounds when a player gets stuck? 1=YES, 0=NO
tVars["sn_emitsounds"] = 1

# Force players to download models, materials and sounds? 1=YES, 0=NO
tVars["sn_downloads"] = 1

# Use a custom model for frag grenades? 1=YES, 0=NO
tVars["sn_newmodel"] = 1

# Power of a frag grenade when not stuck to a player. Default: 100
tVars["sn_grenadenormalpower"] = 100

# Power of a frag grenade when stuck to a player. Default: 100
tVars["sn_grenadestuckpower"] = 300

# Radius of a frag grenade when not stuck to a player. Default: 350
tVars["sn_grenadenormalradius"] = 350

# Radius of a frag grenade when stuck to a player. Default: 350
tVars["sn_grenadestuckradius"] = 350

# Shake player when hit by a stickynade? 1=YES, 0=NO
tVars["sn_shake"] = 1

# Display StickyNades information on round start? 1=YES, 0=NO
tVars["sn_notice"] = 1

#####################
##STOP EDITING HERE##
#####################

vVars = {}
for var in tVars: vVars[var] = es.ServerVar(var, tVars[var])

es.ServerVar("stickynades_ver", info.version, "Version of StickyNades this server is currently using.").makepublic()

def load():
    if not es.ServerVar("eventscripts_currentmap") == "":
        forceDownloads()
        precacheModels()
    es.addons.registerTickListener(tickSticky)

def unload():
    es.addons.unregisterTickListener(tickSticky)

def es_map_start(event_var):
    forceDownloads()
    precacheModels()

def precacheModels():
    global sn_redmodel, sn_bluemodel
    sn_redmodel = es.precachemodel("models/stickynades/stickynades_red.mdl")
    sn_bluemodel = es.precachemodel("models/stickynades/stickynades_blue.mdl")

def forceDownloads():
    files = ["sound/stickynades/muhahaha.wav", "sound/stickynades/scream.wav", "models/stickynades/stickynades_red.dx80.vtx", "models/stickynades/stickynades_red.dx90.vtx", "models/stickynades/stickynades_red.mdl", "models/stickynades/stickynades_red.phy", "models/stickynades/stickynades_red.sw.vtx", "models/stickynades/stickynades_red.vvd", "models/stickynades/stickynades_blue.dx80.vtx", "models/stickynades/stickynades_blue.dx90.vtx", "models/stickynades/stickynades_blue.mdl", "models/stickynades/stickynades_blue.phy", "models/stickynades/stickynades_blue.sw.vtx", "models/stickynades/stickynades_blue.vvd", "materials/models/stickynades/stickynades_blue.vtf", "materials/models/stickynades/stickynades_blue.vmt", "materials/models/stickynades/stickynades_red.vtf", "materials/models/stickynades/stickynades_red.vmt"]
    for file in files: es.stringtable('downloadables', file)

def round_start(event_var):
    if vVars["sn_notice"] == 1:
        es.msg("#multi", "#green[StickyNades]#default is running. Created by #lightgreenJoeyT2008")
        if vVars["sn_fragsticky"] == 1:
            if vVars["sn_sticktowalls"] == 1:
                if vVars["sn_sticktoplayers"] == 1: es.msg("#multi", "#green[StickyNades]#lightgreen Frag Grenades #defaultstick to #lightgreenwalls #defaultand #lightgreenplayers#default.")
            else: es.msg("#multi", "#green[StickyNades]#lightgreen Frag Grenades #defaultstick to #lightgreenwalls#default.")
        else:
            if vVars["sn_sticktoplayers"] == 1: es.msg("#multi", "#green[StickyNades]#lightgreen Frag Grenades #defaultstick to #lightgreenplayers#default.")
    if vVars["sn_flashsticky"] == 1:
        if vVars["sn_sticktowalls"] == 1:
            if vVars["sn_sticktoplayers"] == 1: es.msg("#multi", "#green[StickyNades]#lightgreen Flashbangs #defaultstick to #lightgreenwalls #defaultand #lightgreenplayers#default.")
            else: es.msg("#multi", "#green[StickyNades]#lightgreen Flashbangs #defaultstick to #lightgreenwalls#default.")
        else:
            if vVars["sn_sticktoplayers"] == 1: es.msg("#multi", "#green[StickyNades]#lightgreen Flashbangs #defaultstick to #lightgreenplayers#default.")

def tickSticky():
    try:
        global vPrepared, oldEntList
        if vVars["sn_fragsticky"] == 1:
            entList = es.createentitylist("hegrenade_projectile")
            for index in oldEntList:
                if not index in entList: vPrepared.remove(index)
            oldEntList = entList
            for index in entList:
                if not index in vPrepared and objExists(index):
                    userid = getOwner(index)
                    if es.exists("userid", userid):
                        if vVars["sn_newmodel"] == 1:
                            if es.getplayerteam(userid) == 2: es.setindexprop(index, "CBaseEntity.m_nModelIndex", sn_redmodel)
                            if es.getplayerteam(userid) == 3: es.setindexprop(index, "CBaseEntity.m_nModelIndex", sn_bluemodel)
                            es.setindexprop(index, "CBaseEntity.m_clrRender", -1)
                        es.setindexprop(index, "CBaseGrenade.m_flDamage", es.ServerVar("sn_grenadenormalpower"))
                        es.setindexprop(index, "CBaseGrenade.m_DmgRadius", es.ServerVar("sn_grenadenormalradius"))
                        vPrepared.append(index)
    except: pass

def objExists(index):
    try:
        if es.getindexprop(index, "CBaseGrenade.m_hThrower") == None: return False
        else: return True
    except: return False

def grenade_bounce(event_var):
    data = getGrenadeProperties(event_var["userid"])
    if data:
        index = data.split(":")[0]
        if vVars["sn_sticktowalls"] == 1: es.setindexprop(index, "CBaseEntity.movetype", 0)
        getTarget(es.getindexprop(index, "CBaseEntity.m_vecOrigin"), 80, playerlib.getPlayerList('#all'), event_var["userid"], index)

def getTarget(gLoc, minRadius, playerList, userid, index):
    nearid = None
    maxRadius = 50000
    for tID in playerList:
        if (not int(tID.attributes['isdead'])) and int(tID.attributes['teamid'])>1:
                tLoc = vecmath.vector((tID.attributes['x'], tID.attributes['y'], tID.attributes['z']))
                distance = vecmath.distance(tLoc, gLoc)
                if distance <= maxRadius:
                    maxRadius = distance
                    nearid = tID
    if nearid:
        if maxRadius <= minRadius: stickPlayer(int(userid), int(nearid), int(index))

def getGrenadeProperties(userid):
    for grenade in ["hegrenade", "flashbang"]:
        entList = es.createentitylist("%s_projectile" % grenade)
        for index in entList:
            if int(getOwner(index)) == int(userid): return "%d:%s" % (index, grenade)
    return None

def getOwner(index):
    return es.getuserid(es.getindexprop(index, "CBaseGrenade.m_hThrower"))

def shakePlayer(userid, magnitude, time):
    if es.exists('userid', userid):
        es.usermsg('create', 'shake', 'Shake')
        es.usermsg('write', 'byte', 'shake', 0)
        es.usermsg('write', 'float', 'shake', magnitude)
        es.usermsg('write', 'float', 'shake', 1.0)
        es.usermsg('write', 'float', 'shake', time)
        es.usermsg('send', 'shake', userid)
        es.usermsg('delete','shake')

def stickPlayer(userid, nearid, index):
    if vVars["sn_sticktoplayers"] == 1:
        type = None
        for grenade in ["hegrenade", "flashbang"]:
            for tIndex in es.createentitylist("%s_projectile" % grenade):
                if int(tIndex) == int(index): type = grenade
        if type:
            es.setindexprop(index, "CBaseEntity.movetype", 0)
            if type == "hegrenade":
                es.setindexprop(index, "CBaseGrenade.m_flDamage", es.ServerVar("sn_grenadestuckpower"))
                es.setindexprop(index, "CBaseGrenade.m_DmgRadius", es.ServerVar("sn_grenadestuckradius"))
                if userid == nearid:
                    if vVars["sn_sticktothrower"] == 1: es.msg("#multi", "#green[StickyNades]#lightgreen%s#default stuck himself with a #lightgreenFrag Grenade#default!" % es.getplayername(userid))
                else: es.msg("#multi", "#green[StickyNades]#lightgreen%s#default stuck#lightgreen %s#default with a #lightgreenFrag Grenade#default!" % (es.getplayername(userid), es.getplayername(nearid)))
            if type == "flashbang":
                if userid == nearid:
                    if vVars["sn_sticktothrower"] == 1: es.msg("#multi", "#green[StickyNades]#lightgreen%s#default stuck himself with a #lightgreenFlashbang#default!" % es.getplayername(userid))
                else: es.msg("#multi", "#green[StickyNades]#lightgreen%s#default stuck#lightgreen %s#default with a #lightgreenFlashbang#default!" % (es.getplayername(userid), es.getplayername(nearid)))
            if vVars["sn_emitsounds"] == 1:
                if not userid == nearid:
                    es.emitsound("player", userid, "stickynades/muhahaha.wav", 1, 0.5)
                    es.emitsound("player", nearid, "stickynades/scream.wav", 1, 0.5)
                else:
                    if vVars["sn_sticktothrower"] == 1: es.emitsound("player", userid, "stickynades/scream.wav", 1, 0.5)
            if vVars["sn_shake"] == 1:
                if not userid == nearid: shakePlayer(nearid, 50, 1)
                else:
                    if vVars["sn_sticktothrower"] == 1: shakePlayer(userid, 50, 1)
            if userid == nearid and vVars["sn_sticktothrower"] == 1 or not userid == nearid:
                nade = "nade" + str(nearid)
                if es.exists("variable", "est_version"): es.server.cmd("est_setentname %d %s" % (index, nade))
                else: es.server.cmd("setentname %d %s" % (index, nade))
                user = "user" + str(nearid)
                es.server.cmd('es_fire %s !self addoutput "targetname %s"' % (nearid, user))
                es.server.cmd("es_fire %s %s SetParent %s" % (nearid, nade, user))
                es.server.cmd("es_fire %s %s SetAnimation idle" % (nearid, nade))
                es.server.cmd('es_fire %s %s addoutput "angles 0 0 0"' % (nearid, nade))
                es.server.cmd('es_fire %s %s addoutput "solid 0"' % (nearid, nade))
                es.server.cmd("es_fire %s %s FireUser1" % (nearid, nade))